language: rust
rust:
- stable
+ - beta
+ - 1.22.0
cache: cargo
+
+before_install:
+ - sudo apt-get -qq update
+ - sudo apt-get install -y binutils-dev libunwind8-dev
+
+script:
+ - cargo build --verbose
+ - cargo test --verbose
+ - if [ "$(rustup show | grep default | grep stable)" != "" ]; then cd fuzz && cargo test --verbose && ./travis-fuzz.sh; fi
--- /dev/null
+#!/bin/bash
+cargo install honggfuzz
+set +e
+for TARGET in fuzz_targets/*; do
+ FILENAME=$(basename $TARGET)
+ FILE="${FILENAME%.*}"
+ HFUZZ_BUILD_ARGS="--features honggfuzz_fuzz" HFUZZ_RUN_ARGS="-N1000000 --exit_upon_crash -v" cargo hfuzz run $FILE
+ if [ -f hfuzz_workspace/$FILE/HONGGFUZZ.REPORT.TXT ]; then
+ cat hfuzz_workspace/$FILE/HONGGFUZZ.REPORT.TXT
+ for CASE in hfuzz_workspace/$FILE/SIG*; do
+ cat $CASE | xxd -p
+ done
+ exit 1
+ fi
+done